; Please note:
; There is likely no reason for you to be reading this source code.
; It has no comments and will therefore be difficult to follow.
; If you are here to steal my multi-line text input routine, by all means go ahead.
;  It's called "mygettext" and is located at the end of the code.
; If you are here to add more words to the built in list, do so and then tell me
;  so that I can redistribute the longer list.
;
; This file was last modified 2/9/02 6:24PM.


;--> Include Files
#include "ti83plus.inc"
#include "mirage.inc"


;--> Equates
flg =asm_flag1

wrong =saferam1
word =wrong+1
guessed =word+2
totalwordsptr =guessed+26
wordsptr =totalwordsptr+2
numwords =wordsptr+2
buffer =numwords+1


;--> Header
	.org $9d93			;Origin (set back two to account for AsmPrgm)
	.db $BB,$6D			;Compiled AsmPrgm token
	ret				;So TIOS wont run the program
	.db 1				;Identifier as MirageOS program
	.db %00000000,%00000000
	.db %00000111,%11110000
	.db %00000100,%00011000
	.db %00000100,%00100100
	.db %00000100,%00100100
	.db %00000100,%00011000
	.db %00000100,%00010000
	.db %00000100,%01111100
	.db %00000100,%00010000
	.db %00000100,%00010000
	.db %00000100,%00101000
	.db %00000100,%01000100
	.db %00000100,%00000000
	.db %01111111,%11000000
	.db %00000000,%00000000
title:
	.db "Hangman",0				;Zero terminated description
						;Program code starts here
;--> Main Code
start:
	res plotLoc,(iy+plotflags)
	set bufferonly,(iy+plotflag3)
	set 7,(iy+20)
	ld (iy+flg),0
	call gallows
	call dispcirc
	ld b,5
man_loop:
	call displine
	djnz man_loop
	ld hl,splashtext
	ld a,8
	call rightcenter
	call iFastCopy
	call waitkey
p_badkey:
	ld hl,title
	call window
	ld hl,p1text
	ld a,28
	call centertext
	ld a,36
	ld hl,p2text
	call centertext
	bit 3,(iy+flg)
	ld a,28
	jr z,noadd
	ld a,36
noadd:
	ld d,a
	ld e,28
	ld (pencol),de
	ld a,5
	bcall(_vputmap)
	call iFastCopy
	call waitkey
	cp skClear
	ret z
	cp skDown
	jr nz,notdown
	set 3,(iy+flg)
notdown:
	cp skUp
	jr nz,notup
	res 3,(iy+flg)
notup:
	cp sk2nd
	jr nz,p_badkey
startover:
	bit 3,(iy+flg)
	jr z,oneplayer
	bcall(_clrgbuf)
	ld hl,inputtext
	ld de,0
	call setvputs
	ld b,6
textloop:
	push hl
	call vnewline
	pop hl
	bcall(_vputs)
	djnz textloop
	call ifastcopy
	ld hl,28*256+22
	ld (pencol),hl
	ld hl,buffer
	res bufferonly,(iy+plotflag3)
	set plotLoc,(iy+plotflags)
	call mygettext
	set bufferonly,(iy+plotflag3)
	res plotLoc,(iy+plotflags)
	ld hl,numwords
	ld (word),hl
	jr twoplayer
oneplayer:
	bit 7,(iy+flg)
	jr nz,twoplayer
	ld hl,(progptr)
	ld ix,detectstring
	call iDetect
	jr nz,onlystandard
	set 6,(iy+flg)
next_loop:
	push hl
	ld hl,choosewlist
	push de
	call window
	pop de
	pop hl
	ld a,33
	push de
	push hl
	call centertext
	pop hl
	call nextstr
	pop de
	ex de,hl
	call fastcopys
	push hl
	call waitkey
	pop hl
	cp sk2nd
	jr z,found_prog
	cp skClear
	ret z
	bit 6,(iy+flg)
	jr nz,do_detect
	set 6,(iy+flg)
	ld hl,(progptr)
do_detect:
	ld ix,detectstring
	call iDetect
	jr z,next_loop
	res 6,(iy+flg)
	ld hl,stdtext
	jr next_loop
found_prog:
	bit 6,(iy+flg)
	jr z,onlystandard
	ld (wordsptr),de
	inc de
	ld (totalwordsptr),de
	jr twoplayer
onlystandard:
	ld hl,words
	ld (wordsptr),hl
	ld hl,numinlist
	ld (totalwordsptr),hl
twoplayer:
	set 7,(iy+flg)
	bcall(_clrgbuf)
	call makeword
	call do_glist
	call ifastcopy
main_loop:
	call waitkey
	cp skClear
	ret z
	call clearright
	call letters
	jr z,main_loop
	ld e,a
	ld hl,guessed-$41
	add hl,de
	bit 0,(hl)
	jr nz,main_loop
	set 0,(hl)
	push hl
	call do_glist
	ld a,12
	ld hl,(word)
	set 2,(iy+flg)
	call rightcenter
	pop hl
	bit 2,(hl)
	jr nz,letterright
	ld a,(wrong)
	or a
	jr nz,do_refresh
	ld ix,head2
	call dispcirc
	xor a
	jr skip_refresh
do_refresh:
	ld b,a
	ld ix,line3
refresh_loop:
	push af
	call displine
	pop af
	djnz refresh_loop
skip_refresh:
	inc a
	cp 6
	jr z,loser
	ld (wrong),a
letterright:
	bit 2,(iy+flg)
	jr nz,winner
	call iFastCopy
	jr main_loop

winner:
	ld hl,wintext
	jr tryagain
loser:
	ld hl,losetext
tryagain:
	call window
	ld hl,trytext
	ld a,28
	call centertext
redisp:
	ld hl,yestext
	ld de,36*256+37
selected =$+1
	ld a,0
	or a
	jr nz,skipinv
	set textinverse,(iy+textflags)
skipinv:
	call setvputs
	ld a,1<<textinverse
	xor (iy+textflags)
	ld (iy+textflags),a
	ld hl,pencol
	inc (hl)
	inc (hl)
	inc (hl)
	ld hl,notext
	bcall(_vputs)
	res textinverse,(iy+textflags)
	call iFastCopy
badinput:
	call waitkey
	cp skRight
	jr z,right
	cp skLeft
	jr z,left
	cp sk2nd
	jr nz,badinput
select:
	ld a,(selected)
	or a
	ret nz
	jp startover
right:
	ld a,1
	ld (selected),a
	jr redisp
left:
	xor a
	ld (selected),a
	jr redisp


;--> Calls
clearright:
	push af
	ld hl,plotsscreen
	ld de,6
	xor a
	ld c,64
clearright_out:
	add hl,de
	ld b,6
clearright_in:
	ld (hl),a
	inc hl
	djnz clearright_in
	dec c
	jr nz,clearright_out
	pop af
	ret

gallows:
	ld b,8
	ld ix,line1
gallows_loop:
	call displine
	djnz gallows_loop
	ret

makeword:
	call gallows
	ld hl,guessed
	ld b,26
	xor a
	ld (wrong),a
	ld (selected),a
clearguessed_loop
	ld (hl),a
	inc hl
	djnz clearguessed_loop
	bit 3,(iy+flg)
	jr nz,skipfinding
	ld hl,(totalwordsptr)
	ld b,(hl)
	call iRandom
	ld hl,(wordsptr)
	inc a
	ld b,a
findword_loop1:
	ld a,(hl)
findword_loop2:
	call nextstr
	dec a
	jr nz,findword_loop2
	djnz findword_loop1
	ld (word),hl
skipfinding:
	ld hl,(word)
	set 1,(iy+flg)
	ld a,12
	call rightcenter
	ret

waitkey:
	ei
	halt
	bcall(_getcsc)
	or a
	jr z,waitkey
	ret

displine:
	ld d,(ix)
	inc ix
	ld e,(ix)
	inc ix
	ld h,(ix)
	inc ix
	ld l,(ix)
	inc ix
	push ix
	push bc
	call fastlineb
	pop bc
	pop ix
	ret
dispcirc:
	ld a,29
	ld l,64-57
	ld bc,12*256+2
	call ilsprite
	ret


rightcenter:
	ld b,(hl)
	inc hl
	ld (penrow),a
rightcenter_loop:
	push bc
	push hl
	xor a
	ld b,a
	ld c,a
	cpir
	sub c
	add a,a
	cpl
	add a,48+24
	ld (pencol),a
	ld a,(penrow)
	add a,7
	ld (penrow),a
	pop hl
	bit 1,(iy+flg)
	push af
	call nz,modify_string
	bcall(_vputs)
	pop af
	jr z,no_post_modify
	ex de,hl
	call nextstr
no_post_modify:
	pop bc
	djnz rightcenter_loop
	ret

modify_string:
	ex de,hl
	ld bc,op1
	push de
modify_loop:
	ld a,(de)
	ld ixh,a
	or a
	jr z,modify_done
	inc de
	cp $41
	jr c,modify_nl
	cp $5B
	jr nc,modify_nl
	ld hl,guessed-$41
	push bc
	ld c,a
	ld b,0
	add hl,bc
	pop bc
	ld a,(hl)
	set 2,(hl)
	bit 0,(hl)
	jr nz,modify_nl
	ld ixh,$5F
	res 2,(iy+flg)
modify_nl:
	ld a,ixh
	ld (bc),a
	inc bc
	jr modify_loop
modify_done:
	pop de
	ld hl,op1
	xor a
	ld (bc),a
	ret

do_glist:
	ld de,(64-8-8-8+4)*256+48-5
	ld hl,guessedtext
	call setvputs
	ld hl,guessed
	ld d,h
	ld e,l
	ld b,6
	ld ixh,26
do_glist_loop:
	bit 0,(hl)
	jr z,not_guessed
	djnz not_newline
	ld bc,penrow
	ld a,(bc)
	add a,7
	ld (bc),a
	ld a,48-5+2
	dec bc
	ld (bc),a
	ld b,12
not_newline:
	or a
	push hl
	sbc hl,de
	ld a,l
	add a,$41
	push de
	push ix
	bcall(_vputmap)
	pop ix
	pop de
	pop hl
not_guessed:
	inc hl
	dec ixh
	jr nz,do_glist_loop
	ret

window:
	push hl
	ld hl,20*256+25
	ld de,44*256+71
	push hl
	res bufferonly,(iy+plotflag3)
	bcall(_drawrectborderc)
	pop hl
	ld de,27*256+71
	bcall(_fillrect)
	set bufferonly,(iy+plotflag3)
	pop hl
	ld a,21
	set textinverse,(iy+textflags)
	call centertext
	res textinverse,(iy+textflags)
	ret

letters:
	ld hl,tblKeys
	ld e,a
	ld d,0
	add hl,de
	ld a,(hl)
	or a
	ret

cursorflash:
	ld a,(pencol)
	ld d,a
	ld b,a
	ld a,(penrow)
	xor $3F
	ld c,a
	sub 6
	ld e,a
	ld h,2
	bcall(_iline)
	ret

eol =4
bol =5
mygettext:
	res eol,(iy+flg)
	set bol,(iy+flg)
	ld b,12
	xor a
	ld c,a
	ld (numwords),a
nextkey:
	call fastcopys
nokey:
	ei
	halt
	push hl
	push bc
	call cursorflash
	bcall(_getcsc)
	pop bc
	pop hl
	or a
	jr z,nokey
	cp skClear
	jr z,key_clear
	cp skDel
	jr z,key_del
	cp skEnter
	jr z,key_enter
	bit eol,(iy+flg)
	jr nz,nextkey
	res bol,(iy+flg)
	push hl
	ld hl,tblKeys
	ld e,a
	ld d,0
	add hl,de
	ld a,(hl)
	pop hl
	or a
	jr z,nextkey
	ld (hl),a
	inc hl
	call vputa
	djnz nextkey
	set eol,(iy+flg)
	jr nextkey
key_enter:
	ld a,(numwords)
	inc a
	ld (numwords),a
	ld (hl),0
	cp 3
	ret z
	bit bol,(iy+flg)
	jr z,crlf
	dec a
	ret nz
	ld (numwords),a
	jr nextkey
crlf:
	push hl
	call vnewline
	ld hl,pencol
	ld (hl),22
	pop hl
	set bol,(iy+flg)
	res eol,(iy+flg)
	ld b,12
	inc hl
	jr nextkey
key_del:
	call backspace
	ld a,b
	cp 12
	jr nz,nextkey
	jr nextkey
key_clear:
	call backspace
	bit bol,(iy+flg)
	jr z,key_clear
	ld b,12
	jp nextkey
backspace:
	bit bol,(iy+flg)
	jr z,backspace_sameline
	ld a,(numwords)
	or a
	ret z
	res bol,(iy+flg)
	ld d,a
	dec a
	ld (numwords),a
	ld hl,buffer
	xor a
find_spot_loop:
	ld bc,0
	xor a
	cpir
	dec d
	jr nz,find_spot_loop
	dec hl
	sub c
	dec a
	dec a
	push af
	neg
	add a,11
	ld b,a
	pop af
	sla a
	sla a
	add a,26
	ld (pencol),a
	ld a,(penrow)
	sub 7
	ld (penrow),a
backspace_sameline:
	ld (hl),0
	dec hl
	ld a,(pencol)
	sub 4
	ld (pencol),a
	push af
	ld a,6
	call vputa
	pop af
	inc b
	ld (pencol),a
	res eol,(iy+flg)
	xor a
	cp b
	jr nz,notzero
	set eol,(iy+flg)
notzero:
	ld a,12
	cp b
	ret nz
	set bol,(iy+flg)
	or a
	ret
	
;--> Data
inputtext:
	.db "Input the word(s) to use.",0
	.db "Press <Enter> for a new line,",0
	.db "and again when done.",0
	.db "Max. 3 lines@ 12"
	.db " letters/line.",0
	.db "Line 1:",0
	.db "Line 2:",0
	.db "Line 3:",0
p1text:
	.db "1 Player",0
p2text:
	.db "2 Player",0
guessedtext:
	.db "Guessed:"
guessedspace:
	.db " "
tblKeys:
	.db 0,0,0,0,0,0,0,0,0
	.db 0,0,"W","R","M","H",0,0
	.db 0,0,"V","Q","L","G",0,0
	.db 0,"Z","U","P","K","F","C",0
	.db 0,"Y","T","O","J","E","B",0
	.db 0,"X","S","N","I","D","A",0
	.db 0,0,0,0,0,0,0,0

line1:	.db 0,64-1,33,64-1
	.db 0,64-2,33,64-2
	.db 16,64-3,16,64-61
	.db 15,64-3,15,64-61
	.db 17,64-61,33,64-61
	.db 17,64-60,33,64-60
	.db 34,64-61,34,64-58
	.db 35,64-61,35,64-58
head2:	.db %00011111,%10000000
	.db %00100000,%01000000
	.db %01000000,%00100000
	.db %10000000,%00010000
	.db %10000000,%00010000
	.db %10000000,%00010000
	.db %10000000,%00010000
	.db %10000000,%00010000
	.db %10000000,%00010000
	.db %01000000,%00100000
	.db %00100000,%01000000
	.db %00011111,%10000000
line3:	.db 35,64-26,35,64-45
line4:	.db 35,64-41,46,64-46
line5:	.db 35,64-41,24,64-46
line6:	.db 35,64-26,29,64-8
line7:	.db 35,64-26,41,64-8
wintext:	.db "You Win!",0
losetext:	.db "You Lose",0
trytext:	.db "Try again?",0
yestext:	.db "Yes",0
notext:		.db "No",0
Detectstring:	.db "Hg1GL",0
Choosewlist:	.db "Wordlist:",0
stdtext:	.db "Standard",0
splashtext:
	.db 5
	.db "HANGMAN",0
	.db "v2.0",0
	.db 0
	.db "by",0
	.db "GEOFF LYWOOD",0
words:					;this is offset back one "string" for the routine
	.db 1
numinlist: .db 9,0
realwords:
	.db 1
	.db "GIRAFFE",0
	.db 2
	.db "MARDI",0,"GRAS",0
	.DB 1
	.DB "THISTLE",0
	.DB 2
	.DB "EXPERIMENTAL",0,"ERROR",0
	.DB 1
	.DB "STOWAWAY",0
	.DB 3
	.DB "WHEN",0,"OPPORTUNITY",0,"KNOCKS",0
	.DB 2
	.DB "BASSET",0,"HOUND",0
	.db 1
	.db "BROADEN",0
	.db 3
	.db "WAR",0,"AND",0,"PEACE",0

.end